﻿<%@ page language="java" contentType="text/html; charset=utf-8"
	pageEncoding="utf-8"%>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>具有内爆音的语言分布图</title>
<style>
</style>
<link rel="stylesheet"
	href="/lib/arcgis_js_api/library/4.4/esri/css/main.css">
<link rel="stylesheet"
	href="/lib/arcgis_js_api/library/4.4/dijit/themes/nihilo/nihilo.css">
<link rel="stylesheet" href="/lib/lgis-1.1.1/themes/base/lgis.css">
<link rel="stylesheet" href="map11.css">
<script>
	var dojoConfig = {
		parseOnLoad : true,
		async : true,
		packages : [ {
			name : "dojo",
			location : "/lib/arcgis_js_api/library/4.4/dojo"
		}, {
			name : "dijit",
			location : "/lib/arcgis_js_api/library/4.4/dijit"
		}, {
			name : "dojox",
			location : "/lib/arcgis_js_api/library/4.4/dojox"
		}, {
			name : "gridx",
			location : "/lib/gridx-1.3.9"
		}, {
			name : "esri",
			location : "/lib/arcgis_js_api/library/4.4/esri"
		}, {
			name : "lgis",
			location : "/lib/lgis-1.1.1"
		} ],
		has : {
			"dojo-firebug" : true,
			"dojo-debug-messages" : true,
		},
		isDebug : true,
		debugContainerId : "debugContainerDiv"
	};
</script>
<script src="/lib/arcgis_js_api/library/4.4/init.js"></script>
<script>
	require(
			[ "esri/views/MapView", "esri/Basemap", "esri/Map",
					"esri/layers/FeatureLayer",
					"esri/geometry/support/jsonUtils", "esri/geometry/Extent",
					"esri/geometry/Point", "esri/layers/TileLayer", "esri/renderers/support/jsonUtils",
					"esri/renderers/SimpleRenderer",
					"esri/renderers/UniqueValueRenderer",
					"esri/symbols/SimpleLineSymbol",
					"esri/symbols/SimpleMarkerSymbol", "esri/symbols/TextSymbol", "esri/widgets/Legend", "esri/request", "dojo/_base/array", "dojo/dom", "dojo/on",
					"dojo/domReady!" ],
			function(MapView, Basemap, Map, FeatureLayer, geometryJsonUtils,
					Extent, Point, TileLayer, renderersJsonUtils, SimpleRenderer,
					UniqueValueRenderer, SimpleLineSymbol, SimpleMarkerSymbol, TextSymbol,
					Legend, esriRequest, arrayUtils, dom, on) {

				var legend;

				var boundaryFields = [ {
					name : "ObjectID",
					alias : "ObjectID",
					type : "oid"
				}, {
					name : "boundary",
					alias : "边界",
					type : "string"
				} ];

				// Set up popup template for the layer
				var pTemplate = {
					title : "{title}",
					content : [ {
						type : "fields",
						fieldInfos : [ {
							fieldName : "toponym",
							label : "地名",
							visible : true
						}, {
							fieldName : "value",
							label : "特征",
							visible : true
						} ]
					} ],
					fieldInfos : [ {
						fieldName : "time",
						format : {
							dateFormat : "short-date-short-time"
						}
					} ]
				};

				/**************************************************
				 * Create the map and view
				 **************************************************/

				var base0Layer = new TileLayer(
						{
							url : "http://thematic.geoq.cn/arcgis/rest/services/ThematicMaps/WorldHydroMap/MapServer"
						});
				var base1Layer = new TileLayer(
						{
							// url : "http://map.geoq.cn/ArcGIS/rest/services/ChinaOnlineStreetColor/MapServer"
							// url : "http://thematic.geoq.cn/arcgis/rest/services/ThematicMaps/administrative_division_boundaryandlabel/MapServer"
							url : "http://thematic.geoq.cn/arcgis/rest/services/ThematicMaps/administrative_division_boundaryLine/MapServer"
						});
				
				var customBasemap = new Basemap({
					baseLayers : [ base0Layer, base1Layer ],
					title : "Custom Basemap",
					id : "myBasemap"
				});

				var map = new Map({
					basemap : customBasemap
				});

				// Create MapView
				var view = new MapView({
					container : "viewDiv",
					zoom : 5,
					center : [ 105, 34 ],
					map : map
				});

				view.ui.components = [];

				var boundaryRenderer = new UniqueValueRenderer({
					field : "boundary",
					uniqueValueInfos : [ {
						value : "大略界线",
						symbol : new SimpleLineSymbol({
							color : [ 64, 128, 128, 255 ],
							width : 4,
							style : "solid"
						}),
						label : "大略界线"
					} ]
				});
				// alert(JSON.stringify(boundaryRenderer.toJSON()));

				var boundaryLayer = null;
				
				var textLayer = null;
				
				var feature0Layer = null;
				var feature0Fields = null;
				var feature0Renderer = null;
				var feature0Source = null;

				var feature1Layer = null;
				var feature1Fields = null;
				var feature1Renderer = null;
				var feature1Source = null;

				var feature2Layer = null;
				var feature2Fields = null;
				var feature2Renderer = null;
				var feature2Source = null;

				var feature3Layer = null;
				var feature3Fields = null;
				var feature3Renderer = null;
				var feature3Source = null;

				view.then(function() {
					getBoundaryData().then(createBoundaryGraphics).then(
							createBoundaryLayer).otherwise(errback);
					
					getFeature0FieldsData().then(getFeature0RendererData).then(getFeature0SourceData)
					.then(createFeature0Graphics)
					.then(createFeature0Layer).then(createLegends).otherwise(errback);

					getFeature1FieldsData().then(getFeature1RendererData).then(getFeature1SourceData)
					.then(createFeature1Graphics)
					.then(createFeature1Layer).otherwise(errback);

					getFeature2FieldsData().then(getFeature2RendererData).then(getFeature2SourceData)
					.then(createFeature2Graphics)
					.then(createFeature2Layer).otherwise(errback);

					getFeature3FieldsData().then(getFeature3RendererData).then(getFeature3SourceData)
					.then(createFeature3Graphics)
					.then(createFeature3Layer).then(function () {
						feature0Layer.visible = true;
						
						setTimeout(function () {
							flashing2();
						}, 2000);
					}).otherwise(errback);

					createTextLayer();
				});
				
				function flashing2() {
												if (feature1Layer.visible && feature2Layer.visible && feature3Layer.visible) {
													feature1Layer.visible = false;
													feature2Layer.visible = false;
													feature3Layer.visible = false;
													
													setTimeout(function () {
														flashing2();
													}, 1000);
												} else {
													feature1Layer.visible = true;
													feature2Layer.visible = true;
													feature3Layer.visible = true;
													
													setTimeout(function () {
														flashing2();
													}, 3000);
												}
				}
				
				function getBoundaryData() {
					return esriRequest("data/map11_boundary.json", {
						responseType : "json",
						cacheBust : true
					});
				}

				function createBoundaryGraphics(response) {
					// raw GeoJSON data
					var geoJson = response.data;

					// Create an array of Graphics from each GeoJSON feature
					return arrayUtils
							.map(
									geoJson.features,
									function(feature, i) {
										// alert(toGeometryFromString(feature.geometry));
										return {
											geometry : toGeometryFromString(feature.geometry),
											// select only the attributes you care about
											attributes : {
												ObjectID : i,
												boundary : "大略界线"
											}
										};
									});
				}

				function createBoundaryLayer(graphics) {
					// alert(JSON.stringify(graphics));
					boundaryLayer = new FeatureLayer({
						title : "古百越文化区历史图层",
						source : graphics,
						fields : boundaryFields,
						objectIdField : "ObjectID",
						renderer : boundaryRenderer,
						spatialReference : {
							wkid : 4326
						},
						geometryType : "polyline",
						popupTemplate : pTemplate
					});
					boundaryLayer.visible = true;

					map.add(boundaryLayer);
				}

				function createTextLayer() {
					textLayer = new FeatureLayer({
						title : "标记图层",
						source : [ {
							geometry : new Point({
								x : 109.0730400000,
								y : 24.9286100000
							}),
							attributes : {
								ObjectID : 1,
								value : "古百越文化区"
							}
						} ],
						fields : [ {
							name : "ObjectID",
							alias : "图例",
							type : "oid"
						}, {
							name : "value",
							alias : "地区",
							type : "string"
						} ],
						objectIdField : "ObjectID",
						renderer : new UniqueValueRenderer({
							field : "value",
							uniqueValueInfos : [ {
								value : "古百越文化区",
								symbol : new TextSymbol({
									color : [ 64, 128, 128, 255 ],
									haloColor : "black",
									haloSize : "1px",
									text : "古 百 越 文 化 区",
									xoffset : 3,
									yoffset : 3,
									font : {
										size : 24,
										style : "oblique",
										family : "serif",
										weight : "bold"
									}
								}),
								label : "古百越文化区"
							} ]
						}),
						spatialReference : {
							wkid : 4326
						},
						geometryType : "point",
						popupTemplate : pTemplate
					});
					textLayer.visible = true;

					map.add(textLayer);
				}

				// feature0
				function getFeature0FieldsData() {
					return esriRequest("data/map11_feature0_fields.json", {
						responseType : "json",
						cacheBust : true
					});
				}

				function getFeature0RendererData(response) {
					feature0Fields = response.data;

					return esriRequest("data/map11_feature0_renderer.json", {
						responseType : "json",
						cacheBust : true
					});
				}

				function getFeature0SourceData(response) {
					var feature0RendererJSON = response.data;
					feature0Renderer = renderersJsonUtils
							.fromJSON(feature0RendererJSON);

					return esriRequest("data/map11_feature0_source.json", {
						responseType : "json",
						cacheBust : true
					});
				}

				function createFeature0Graphics(response) {
					feature0Source = response.data;

					return arrayUtils.map(feature0Source, function(feature, i) {
						var geometry = null;
						if (feature.geometry != null) {
							geometry = new Point({
								x : feature.geometry.x,
								y : feature.geometry.y
							});
						}
						return {
							geometry : geometry,
							attributes : {
								ObjectID : i,
								toponym : feature.attributes.toponym,
								data : feature.attributes.data,
								value : feature.attributes.value
							}
						};
					});
				}

				function createFeature0Layer(graphics) {
					feature0Layer = new FeatureLayer({
						title : "方言分布",
						source : graphics,
						fields : feature0Fields,
						objectIdField : "ObjectID",
						renderer : feature0Renderer,
						spatialReference : {
							wkid : 4326
						},
						geometryType : "point",
						popupTemplate : pTemplate
					});
					feature0Layer.visible = false;

					map.add(feature0Layer);
				}

				// feature1
				function getFeature1FieldsData() {
					return esriRequest("data/map11_feature1_fields.json", {
						responseType : "json",
						cacheBust : true
					});
				}

				function getFeature1RendererData(response) {
					feature1Fields = response.data;

					return esriRequest("data/map11_feature1_renderer.json", {
						responseType : "json",
						cacheBust : true
					});
				}

				function getFeature1SourceData(response) {
					var feature1RendererJSON = response.data;
					feature1Renderer = renderersJsonUtils
							.fromJSON(feature1RendererJSON);

					return esriRequest("data/map11_feature1_source.json", {
						responseType : "json",
						cacheBust : true
					});
				}

				function createFeature1Graphics(response) {
					feature1Source = response.data;

					return arrayUtils.map(feature1Source, function(feature, i) {
						var geometry = null;
						if (feature.geometry != null) {
							geometry = new Point({
								x : feature.geometry.x,
								y : feature.geometry.y
							});
						}
						return {
							geometry : geometry,
							attributes : {
								ObjectID : i,
								toponym : feature.attributes.toponym,
								data : feature.attributes.data,
								value : feature.attributes.value
							}
						};
					});
				}

				function createFeature1Layer(graphics) {
					feature1Layer = new FeatureLayer({
						title : "方言分布",
						source : graphics,
						fields : feature1Fields,
						objectIdField : "ObjectID",
						renderer : feature1Renderer,
						spatialReference : {
							wkid : 4326
						},
						geometryType : "point",
						popupTemplate : pTemplate
					});
					feature1Layer.visible = false;

					map.add(feature1Layer);
				}
				
				// feature2
				function getFeature2FieldsData() {
					return esriRequest("data/map11_feature2_fields.json", {
						responseType : "json",
						cacheBust : true
					});
				}

				function getFeature2RendererData(response) {
					feature2Fields = response.data;

					return esriRequest("data/map11_feature2_renderer.json", {
						responseType : "json",
						cacheBust : true
					});
				}

				function getFeature2SourceData(response) {
					var feature2RendererJSON = response.data;
					feature2Renderer = renderersJsonUtils
							.fromJSON(feature2RendererJSON);

					return esriRequest("data/map11_feature2_source.json", {
						responseType : "json",
						cacheBust : true
					});
				}

				function createFeature2Graphics(response) {
					feature2Source = response.data;

					return arrayUtils.map(feature2Source, function(feature, i) {
						var geometry = null;
						if (feature.geometry != null) {
							geometry = new Point({
								x : feature.geometry.x,
								y : feature.geometry.y
							});
						}
						return {
							geometry : geometry,
							attributes : {
								ObjectID : i,
								toponym : feature.attributes.toponym,
								data : feature.attributes.data,
								value : feature.attributes.value
							}
						};
					});
				}

				function createFeature2Layer(graphics) {
					feature2Layer = new FeatureLayer({
						title : "方言分布",
						source : graphics,
						fields : feature2Fields,
						objectIdField : "ObjectID",
						renderer : feature2Renderer,
						spatialReference : {
							wkid : 4326
						},
						geometryType : "point",
						popupTemplate : pTemplate
					});
					feature2Layer.visible = false;

					map.add(feature2Layer);
				}
				
				// feature3
				function getFeature3FieldsData() {
					return esriRequest("data/map11_feature3_fields.json", {
						responseType : "json",
						cacheBust : true
					});
				}

				function getFeature3RendererData(response) {
					feature3Fields = response.data;

					return esriRequest("data/map11_feature3_renderer.json", {
						responseType : "json",
						cacheBust : true
					});
				}

				function getFeature3SourceData(response) {
					var feature3RendererJSON = response.data;
					feature3Renderer = renderersJsonUtils
							.fromJSON(feature3RendererJSON);

					return esriRequest("data/map11_feature3_source.json", {
						responseType : "json",
						cacheBust : true
					});
				}

				function createFeature3Graphics(response) {
					feature3Source = response.data;

					return arrayUtils.map(feature3Source, function(feature, i) {
						var geometry = null;
						if (feature.geometry != null) {
							geometry = new Point({
								x : feature.geometry.x,
								y : feature.geometry.y
							});
						}
						return {
							geometry : geometry,
							attributes : {
								ObjectID : i,
								toponym : feature.attributes.toponym,
								data : feature.attributes.data,
								value : feature.attributes.value
							}
						};
					});
				}

				function createFeature3Layer(graphics) {
					feature3Layer = new FeatureLayer({
						title : "方言分布",
						source : graphics,
						fields : feature3Fields,
						objectIdField : "ObjectID",
						renderer : feature3Renderer,
						spatialReference : {
							wkid : 4326
						},
						geometryType : "point",
						popupTemplate : pTemplate
					});
					feature3Layer.visible = false;

					map.add(feature3Layer);
				}
				
				function createLegends() {
					if (legend) {
						legend.layerInfos = [ {
							layer : feature0Layer,
							title : feature0Layer.title
						}, {
							layer : boundaryLayer,
							title : boundaryLayer.title
						} ];
					} else {
						legend = new Legend({
							view : view,
							layerInfos : [ {
								layer : feature0Layer,
								title : feature0Layer.title
							}, {
								layer : boundaryLayer,
								title : boundaryLayer.title
							} ]
						}, "infoDiv");
					}
				}

				// Executes if data retrieval was unsuccessful.
				function errback(error) {
					console.error("Creating legend failed. ", error);
				}

				function toGeometryFromString(string) {
					var geometry = null;

					if (string != null) {
						if (string.indexOf("POINT (") == 0
								&& string.lastIndexOf(")") == string.length
										- ")".length) {
							string = string.substring("POINT (".length,
									string.length - ")".length);
							var stringArray = string.split(" ");
							geometry = geometryJsonUtils.fromJSON({
								x : stringArray[0],
								y : stringArray[1],
								spatialReference : {
									wkid : 4326
								}
							});
						} else if (string.indexOf("MULTILINESTRING (") == 0
								&& string.lastIndexOf(")") == string.length
										- ")".length) {
							string = string.substring(
									"MULTILINESTRING (".length, string.length
											- ")".length);
							var stringArray = string.split("), ");
							var path = new Array();
							for (var stringArrayIndex = 0; stringArrayIndex < stringArray.length; stringArrayIndex++) {
								var string2 = stringArray[stringArrayIndex];
								if (string2.indexOf("(") == 0) {
									string2 = string2.substring("(".length);
								}
								if (string2.lastIndexOf(")") == string2.length
										- ")".length) {
									string2 = string2.substring(0,
											string2.length - ")".length);
								}
								var stringArray2 = string2.split(", ");
								var path2 = new Array();
								for (var stringArray2Index = 0; stringArray2Index < stringArray2.length; stringArray2Index++) {
									var stringArray3 = stringArray2[stringArray2Index]
											.split(" ");
									path2.push([ Number(stringArray3[0]),
											Number(stringArray3[1]) ]);
								}
								path.push(path2);
							}
							geometry = geometryJsonUtils.fromJSON({
								paths : path,
								spatialReference : {
									wkid : 4326
								}
							});
						} else if (string.indexOf("MULTIPOLYGON (") == 0
								&& string.lastIndexOf(")") == string.length
										- ")".length) {
							string = string.substring("MULTIPOLYGON (".length,
									string.length - ")".length);
							var stringArray = string.split(")), ");
							var path = new Array();
							for (var stringArrayIndex = 0; stringArrayIndex < stringArray.length; stringArrayIndex++) {
								var string2 = stringArray[stringArrayIndex];
								var mainString2 = string2.substring("(".length,
										string2.length - ")".length);
								if (mainString2.indexOf("(") == 0) {
									mainString2 = mainString2
											.substring("(".length);
								}
								if (mainString2.lastIndexOf(")") == mainString2.length
										- ")".length) {
									mainString2 = mainString2.substring(0,
											mainString2.length - ")".length);
								}
								var stringArray2 = mainString2.split(", ");
								var path2 = new Array();
								for (var stringArray2Index = 0; stringArray2Index < stringArray2.length; stringArray2Index++) {
									var stringArray3 = stringArray2[stringArray2Index]
											.split(" ");
									path2.push([ Number(stringArray3[0]),
											Number(stringArray3[1]) ]);
								}
								path.push(path2);
							}
							geometry = geometryJsonUtils.fromJSON({
								rings : path,
								spatialReference : {
									wkid : 4326
								}
							});
						}
					}
					return geometry;
				}
			});
</script>
</head>
<body class="nihilo">
	<div id="viewDiv"></div>
	<div id="infoDiv">
		<h2>具有内爆音的语言分布图</h2>
		<p>内爆音的分布与百越文化相关。有内爆音的民族语、有内爆音的汉语方言、底层有内爆音的汉语方言主要分布在长江以南的百越文化区域。</p>
	</div>
	<div id="debugContainerDiv" style="display: none;"></div>
</body>
</html>